/* * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#ifndef _ATANYURITESTER_HPP
#define _ATANYURITESTER_HPP

#include <xercesc/util/XercesDefs.hpp>
#include "DatatypeTester.hpp"

class DynamicContext;
class XPath2MemoryManager;
class ATAnyURIOrDerived;

/**
 * Tests ATAnyURIOrDerived
 */
class ATAnyURITester: public DatatypeTester {
public: 
  ATAnyURITester(XPath2MemoryManager* memMgr);
   
  // use default
  // virtual void init();

  virtual void run(const DynamicContext* context);
  
  // use default
  // virtual void wrapUp();
private:
  const ATAnyURIOrDerived* createURI(const XMLCh* value,
                                     const DynamicContext* context);
};


#endif //_ATANYURITESTER_HPP
