/* * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#ifndef _ATBASE64BINARYTESTER_HPP
#define _ATBASE64BINARYTESTER_HPP

#include <xercesc/util/XercesDefs.hpp>
#include "DatatypeTester.hpp"

class DynamicContext;
class XPath2MemoryManager;
class ATBase64BinaryOrDerived;

/**
 * Tests ATBase64BinaryOrDerived
 */
class ATBase64BinaryTester: public DatatypeTester {
public: 
  ATBase64BinaryTester(XPath2MemoryManager* memMgr);
   
  // use default
  // virtual void init();

  virtual void run(const DynamicContext* context);
  
  // use default
  // virtual void wrapUp();
private:
  const ATBase64BinaryOrDerived* createBinary(const XMLCh* value,
                                     const DynamicContext* context);
};


#endif //_ATBASE64BINARYTESTER_HPP
