#include "../config/pathan_config.h"
/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#include <pathan/Item.hpp>


Item::Item(XPath2MemoryManager* memMgr): _memMgr(memMgr) {}

Item::Item(const Item & other) {
  _memMgr = other._memMgr;
}

Item & Item::operator=(const Item & b) {
  if(this != &b) {
    _memMgr = b._memMgr;
  }
  return *this;
}

XPath2MemoryManager* Item::getMemoryManager() const {
	return _memMgr;
}
