#include "../config/pathan_config.h"
/*
 * Copyright (c) 2003, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */


#include <pathan/PathanTypeInfo.hpp>
#include <pathan/XPath2MemoryManager.hpp>

PathanTypeInfo::PathanTypeInfo(const XMLCh* uri, const XMLCh* name, XPath2MemoryManager* memMgr) {
  _uri = memMgr->getPooledString(uri);
  _name = memMgr->getPooledString(name);
}

PathanTypeInfo::~PathanTypeInfo() {
 // no-op
}

const XMLCh* PathanTypeInfo::getName() const {
  return _name;
}

const XMLCh* PathanTypeInfo::getNamespace() const {
  return _uri;
}


