#include "../config/pathan_config.h"
/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#include <pathan/internal/navigation/SelfAxis.hpp>

#include <pathan/Node.hpp>

NavStepImpl::Axis SelfAxis::getAxis() const {
  return NavStepImpl::SELF;
}

Sequence SelfAxis::makeList(const XERCES_CPP_NAMESPACE_QUALIFIER DOMNode *node, const XMLCh* const uri, DynamicContext* context) const
{
  XPath2MemoryManager* memMgr=context->getMemoryManager();
  Sequence retList(memMgr);
  if(filterNode(node, uri, context))
    retList.addItem(memMgr->createNode(node));
  return retList;
}//makeList
