/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#ifndef _TOTALORDERCOMPARISON_HPP
#define _TOTALORDERCOMPARISON_HPP



#include <pathan/dataItem/DataItemOperator.hpp>

/** OpPlus operator function*/
class PATHAN_EXPORT TotalOrderComparison : public DataItemOperator
{
public:
	//greaterThan should be set to true if you want to param1 > param2 
  TotalOrderComparison(const VectorOfDataItems &args, bool greatherThan, XPath2MemoryManager* memMgr);

	//if greaterThan is true then this method returns true if the first value is greater than the second 
  Sequence collapseTreeInternal(DynamicContext* context, int flags=0) const;

private:
	bool _greaterThan;
};

#endif // _FUNCTIONTOTALORDER_HPP
