/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*
  Definition of parser control struct.

  This is needed by Xparser.y, test.cpp and ../lexer/XPathLexer.cpp.
*/

#ifndef _XPATHPARSERCONTROL_HPP
#define _XPATHPARSERCONTROL_HPP



#include <pathan/dataItem/DataItem.hpp>
#include <pathan/StaticContext.hpp>

//typedef unsigned int YY_CHAR;
class xxFlexLexer;
class XPath2MemoryManager;

//#include <FlexLexer.h>

class PATHAN_EXPORT XPathParserControl {

public:
  DataItem* result;
  xxFlexLexer *lexer;
	const DynamicContext* context;
	XPath2MemoryManager* memMgr;

  //for string interpolator - check
  XPathParserControl(void)
    : result(NULL)
  {
  };

  XPathParserControl(DataItem *impl)
    : result(impl)
  {
  };
};

#endif // _XPATHPARSERC:ONTROL_HPP
